#include "PedsFullNoiseAnalysisDescription.h"
#include <iostream>
#include <vector>
 
 
  const char *PedsFullNoiseAnalysisDescription::PEDSFULLNOISEANALYSISDESCRIPTION[] =
{"deadStrips","badStrips","shiftedStrips","lowNoiseStrips","largeNoiseStrips","largeNoiseSignificance","badFitStatus","badADProbab","badKSProbab","badJBProbab","badChi2Probab","badTailStrips",
 "badDoublePeakStrips","deadStripBit","badStripBit","reasonBadStripBit",
 "adProbab","ksProbab","jbProbab","chi2Probab","noiseRMS","noiseSigmaGaus","noiseSignificance","residualSkewness","residualKurtosis","residualIntegralNsigma","residualIntegral","fractionOverN",};
 
 
////////////////////// CON(DE)STRUCTOR ////////////////////////////
 
 
//------------------------------------
PedsFullNoiseAnalysisDescription::PedsFullNoiseAnalysisDescription() {}
 
//------------------------------------
PedsFullNoiseAnalysisDescription::PedsFullNoiseAnalysisDescription(VInt16 deadStrips,
                                                                   VInt16 badStrips,
                                                                   VInt16 shiftedStrips,
                                                                   VInt16 lowNoiseStrips,
                                                                   VInt16 largeNoiseStrips,
                                                                   VInt16 largeNoiseSignificance,
                                                                   VInt16 badFitStatus,
                                                                   VInt16 badADProbab,
                                                                   VInt16 badKSProbab,
                                                                   VInt16 badJBProbab,
                                                                   VInt16 badChi2Probab,
                                                                   VInt16 badTailStrips,
                                                                   VInt16 badDoublePeakStrips,
                                                                   VFloat adProbab,
                                                                   VFloat ksProbab,
                                                                   VFloat jbProbab,
                                                                   VFloat chi2Probab,
                                                                   VFloat noiseRMS,
                                                                   VFloat noiseSigmaGaus,
                                                                   VFloat noiseSignificance,
                                                                   VFloat residualSkewness,
                                                                   VFloat residualKurtosis,
                                                                   VFloat residualIntegralNsigma,
                                                                   VFloat residualIntegral,
                                                                   uint16_t crate,
                                                                   uint16_t slot,
                                                                   uint16_t ring,
                                                                   uint16_t ccuAdr,
                                                                   uint16_t ccuChan,
                                                                   uint16_t i2cAddr,
                                                                   std::string partition,
                                                                   uint32_t runNumber,
                                                                   bool valid,
                                                                   std::string comments,
                                                                   uint16_t fedId,
                                                                   uint16_t feUnit,
                                                                   uint16_t feChan,
                                                                   uint16_t fedApv                              
                                                                   ) :
CommissioningAnalysisDescription (crate,slot,ring,ccuAdr,ccuChan,i2cAddr,partition,runNumber,valid,comments,fedId,feUnit,feChan,fedApv) {
  this->setDeadStrips(deadStrips);
  this->setBadStrips(badStrips);
  this->setShiftedStrips(shiftedStrips);
  this->setLowNoiseStrips(lowNoiseStrips);
  this->setLargeNoiseStrips(largeNoiseStrips);
  this->setLargeNoiseSignifStrips(largeNoiseSignificance);
  this->setBadFitStrips(badFitStatus);
  this->setBadADProbabStrips(badADProbab);
  this->setBadKSProbabStrips(badKSProbab);
  this->setBadJBProbabStrips(badJBProbab);
  this->setBadChi2ProbabStrips(badChi2Probab);
  this->setBadTailStrips(badTailStrips);
  this->setBadDoublePeakStrips(badDoublePeakStrips);
  this->setADProbab(adProbab);
  this->setKSProbab(ksProbab);
  this->setJBProbab(jbProbab);
  this->setChi2Probab(chi2Probab);
  this->setNoiseRMS(noiseRMS);
  this->setNoiseSigmaGaus(noiseSigmaGaus);
  this->setNoiseSignificance(noiseSignificance);
  this->setResidualSkewness(residualSkewness);
  this->setResidualKurtosis(residualKurtosis);
  this->setResidualIntegral(residualIntegral);
  this->setResidualIntegralNsigma(residualIntegralNsigma);
  this->setDeadStripBit();
  this->setBadStripBit();
  this->setReasonBadStripBit();
  this->setFractionOverN();
}
 
 
//------------------------------------
PedsFullNoiseAnalysisDescription::PedsFullNoiseAnalysisDescription(uint16_t crate,
                                                                   uint16_t slot,
                                                                   uint16_t ring,
                                                                   uint16_t ccuAdr,
                                                                   uint16_t ccuChan,
                                                                   uint16_t i2cAddr,
                                                                   std::string partition,
                                                                   uint32_t runNumber,
                                                                   bool valid,
                                                                   std::string comments,
                                                                   uint16_t fedId,
                                                                   uint16_t feUnit,
                                                                   uint16_t feChan,
                                                                   uint16_t fedApv                              
                                                                   ) :
CommissioningAnalysisDescription (crate,slot,ring,ccuAdr,ccuChan,i2cAddr,partition,runNumber,valid,comments,fedId,feUnit,feChan,fedApv) {}
 
//------------------------------------
PedsFullNoiseAnalysisDescription::PedsFullNoiseAnalysisDescription(parameterDescriptionNameType parameterNames) : CommissioningAnalysisDescription ( parameterNames ) {
 
  setDeadStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[DEAD]]->getValue());
  setBadStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BAD]]->getValue());
  setShiftedStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[SHIFT]]->getValue());
  setLowNoiseStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LOWNOISE]]->getValue());
  setLargeNoiseStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LARGENOISE]]->getValue());
  setLargeNoiseSignifStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LARGESIGNIF]]->getValue());
  setBadFitStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADFIT]]->getValue());
  setBadADProbabStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADADPROB]]->getValue());
  setBadKSProbabStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADKSPROB]]->getValue());
  setBadJBProbabStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADJBPROB]]->getValue());
  setBadChi2ProbabStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADCHI2PROB]]->getValue());
  setBadTailStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADTAIL]]->getValue());
  setBadDoublePeakStrips(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADDOUBLEPEAK]]->getValue());
  setADProbab(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[ADPROBAB]]->getValue());
  setKSProbab(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[KSPROBAB]]->getValue());
  setJBProbab(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[JBPROBAB]]->getValue());
  setChi2Probab(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[CHI2PROBAB]]->getValue());
  setNoiseRMS(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISERMS]]->getValue());
  setNoiseSigmaGaus(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGMAGAUS]]->getValue());
  setNoiseSignificance(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGNIF]]->getValue());
  setResidualSkewness(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESSKEWNESS]]->getValue());
  setResidualKurtosis(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESKURTOSIS]]->getValue());
  setResidualIntegral(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRAL]]->getValue());
  setResidualIntegralNsigma(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRALNSIGMA]]->getValue());
  setDeadStripBit(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[DEADBIT]]->getValue());
  setBadStripBit(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADBIT]]->getValue());
  setReasonBadStripBit(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[REASONBIT]]->getValue());
  setFractionOverN(parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[FRACTIONOVERN]]->getValue());
 
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[DEAD]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BAD]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[SHIFT]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LOWNOISE]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LARGENOISE]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[LARGESIGNIF]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADFIT]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADADPROB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADKSPROB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADJBPROB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADCHI2PROB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADTAIL]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADDOUBLEPEAK]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[DEADBIT]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[BADBIT]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[REASONBIT]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[ADPROBAB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[KSPROBAB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[JBPROBAB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[CHI2PROBAB]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISERMS]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGMAGAUS]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGNIF]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESSKEWNESS]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESKURTOSIS]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRAL]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRALNSIGMA]]->setValue("");
  parameterNames[PEDSFULLNOISEANALYSISDESCRIPTION[FRACTIONOVERN]]->setValue("");
}
 
 
 
 
///////////////////////// METHODS ///////////////////////////////
 
//------------------------------------
std::string PedsFullNoiseAnalysisDescription::toString() {

  std::stringstream ss;
  ss << "Key:" << std::endl;
  ss << CommissioningAnalysisDescription::_toString();
  ss << "PedestalsAnalysis properties:" << std::endl;
  ss << " . Dead               : " << this->getDeadStrips()        << std::endl;
  ss << " . Bad                : " << this->getBadStrips()         << std::endl;
  ss << " . Shifted            : " << this->getShiftedStrips()     << std::endl;
  ss << " . Low Noise          : " << this->getLowNoiseStrips()    << std::endl;
  ss << " . Large Noise        : " << this->getLargeNoiseStrips()  << std::endl;
  ss << " . Large Noise Signif : " << this->getLargeNoiseSignifStrips() << std::endl;
  ss << " . Bad Fits           : " << this->getBadFitStrips()      << std::endl;
  ss << " . Bad AD Probab      : " << this->getBadADProbabStrips() << std::endl;
  ss << " . Bad KS Probab      : " << this->getBadKSProbabStrips() << std::endl;
  ss << " . Bad JB Probab      : " << this->getBadJBProbabStrips() << std::endl;
  ss << " . Bad Chi2 Probab    : " << this->getBadChi2ProbabStrips() << std::endl;
  ss << " . Bad Tail           : " << this->getBadTailStrips() << std::endl;
  ss << " . Bad Double Peak    : " << this->getBadDoublePeakStrips() << std::endl;
  ss << " . Dead Strips Bit    : " << this->getDeadStripBit() << std::endl;
  ss << " . Bad Strips Bit    : " << this->getBadStripBit() << std::endl;
  ss << " . Reason Bad Strips Bit    : " << this->getReasonBadStripBit() << std::endl;
  ss << " . ADProbab    : " << this->getADProbab()    << std::endl;
  ss << " . KSProbab    : " << this->getKSProbab()    << std::endl;
  ss << " . JBProbab    : " << this->getJBProbab()    << std::endl;
  ss << " . Chi2Probab  : " << this->getChi2Probab()  << std::endl;
  ss << " . NoiseRMS    : " << this->getNoiseRMS()    << std::endl;
  ss << " . NoiseSigmaGaus    : " << this->getNoiseSigmaGaus()    << std::endl;
  ss << " . NoiseSignificance : " << this->getNoiseSignificance() << std::endl;
  ss << " . ResidualSkewness  : " << this->getResidualSkewness()  << std::endl;
  ss << " . ResidualKurtosis  : " << this->getResidualKurtosis()  << std::endl;
  ss << " . ResidualIntegral  : " << this->getResidualIntegral()  << std::endl;
  ss << " . ResidualIntegralNsigma  : " << this->getResidualIntegralNsigma()  << std::endl;
  ss << " . FractionOverN  : " << this->getFractionOverN()  << std::endl;
       
  return ss.rdbuf()->str();
}
 
//------------------------------------
CommissioningAnalysisDescription *PedsFullNoiseAnalysisDescription::clone() {  

  PedsFullNoiseAnalysisDescription * c =
    new PedsFullNoiseAnalysisDescription(this->getCrate(),this->getSlot(),this->getRing(),this->getCcuAdr(),this->getCcuChan(),
                                         this->getI2cAddr(),this->getPartition(),this->getRunNumber(),this->isValid(),
                                         this->getSerializedComments(),this->getFedId(),this->getFeUnit(),this->getFeChan(),
                                         this->getFedApv()
                                         );
 
 
  c->setDeadStrips(this->getDeadStrips());
  c->setBadStrips(this->getBadStrips());
  c->setShiftedStrips(this->getShiftedStrips());
  c->setLowNoiseStrips(this->getLowNoiseStrips());
  c->setLargeNoiseStrips(this->getLargeNoiseStrips());
  c->setLargeNoiseSignifStrips(this->getLargeNoiseSignifStrips());
  c->setBadFitStrips(this->getBadFitStrips());
  c->setBadADProbabStrips(this->getBadADProbabStrips());
  c->setBadKSProbabStrips(this->getBadKSProbabStrips());
  c->setBadJBProbabStrips(this->getBadJBProbabStrips());
  c->setBadChi2ProbabStrips(this->getBadChi2ProbabStrips());
  c->setBadTailStrips(this->getBadTailStrips());
  c->setBadDoublePeakStrips(this->getBadDoublePeakStrips());
  c->setADProbab(this->getADProbab());
  c->setKSProbab(this->getKSProbab());
  c->setJBProbab(this->getJBProbab());
  c->setChi2Probab(this->getChi2Probab());
  c->setNoiseRMS(this->getNoiseRMS());
  c->setNoiseSigmaGaus(this->getNoiseSigmaGaus());
  c->setNoiseSignificance(this->getNoiseSignificance());
  c->setResidualSkewness(this->getResidualSkewness());
  c->setResidualKurtosis(this->getResidualKurtosis());
  c->setResidualIntegral(this->getResidualIntegral());
  c->setResidualIntegralNsigma(this->getResidualIntegralNsigma());
  c->setDeadStripBit(this->getDeadStripBit());
  c->setBadStripBit(this->getBadStripBit());
  c->setReasonBadStripBit(this->getReasonBadStripBit());
  c->setFractionOverN(this->getFractionOverN());

  return c;
}
 
 
//------------------------------------
void PedsFullNoiseAnalysisDescription::display() {
  std::cout << this->toString() << std::endl;
}
 
//------------------------------------
 
parameterDescriptionNameType *PedsFullNoiseAnalysisDescription::getParameterNames() {
  parameterDescriptionNameType *parameterNames = CommissioningAnalysisDescription::getParameterNames();
 
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[DEAD]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[DEAD], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BAD]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BAD], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[SHIFT]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[SHIFT], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[LOWNOISE]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[LOWNOISE], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[LARGENOISE]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[LARGENOISE], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[LARGESIGNIF]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[LARGESIGNIF], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADFIT]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADFIT], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADADPROB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADADPROB], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADKSPROB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADKSPROB], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADJBPROB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADJBPROB], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADCHI2PROB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADCHI2PROB], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADTAIL]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADTAIL], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADDOUBLEPEAK]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADDOUBLEPEAK], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[DEADBIT]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[DEADBIT], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[BADBIT]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[BADBIT], ParameterDescription::INTEGER16);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[REASONBIT]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[REASONBIT], ParameterDescription::INTEGER16);
 
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[ADPROBAB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[ADPROBAB], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[KSPROBAB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[KSPROBAB], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[JBPROBAB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[JBPROBAB], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[CHI2PROBAB]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[CHI2PROBAB], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[NOISERMS]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[NOISERMS], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGMAGAUS]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGMAGAUS], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGNIF]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[NOISESIGNIF], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[RESSKEWNESS]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[RESSKEWNESS], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[RESKURTOSIS]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[RESKURTOSIS], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRAL]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRAL], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRALNSIGMA]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[RESINTEGRALNSIGMA], ParameterDescription::REAL);
  (*parameterNames)[PEDSFULLNOISEANALYSISDESCRIPTION[FRACTIONOVERN]] = new ParameterDescription(PEDSFULLNOISEANALYSISDESCRIPTION[FRACTIONOVERN], ParameterDescription::REAL);
 
  return parameterNames;
}
 
 
 
 
//////////////////// GETTERS / SETTERS //////////////////////////
 
/** @brief get human readable analysis type */
std::string PedsFullNoiseAnalysisDescription::getAnalysisType() const {
  return CommissioningAnalysisDescription::getAnalysisType( this->getType() );
}
 
/** @brief set: Dead strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setDeadStrips( const VInt16 value ) {
  this->_deadStrips = value;
}
 
/** @brief set: Dead strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setDeadStrips( const std::string &value ) {
  this->_deadStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_deadStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_deadStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getDeadStrips( VInt16 &value ) {
  value = this->_deadStrips;
}
 
/** @brief get: Dead strips values are strip numbers concatened and separated by '|'. */
std::string PedsFullNoiseAnalysisDescription::getDeadStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_deadStrips.size(); i < size; ++i) {
    ss << sep << this->_deadStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
 
/** @brief set: Bad strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadStrips( const VInt16 value ) {
  this->_badStrips = value;
}
 
/** @brief set: Bad strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadStrips( const std::string &value ) {
  this->_badStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadStrips( VInt16 &value ) {
  value = this->_badStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badStrips.size(); i < size; ++i) {
    ss << sep << this->_badStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: Shifted strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setShiftedStrips( const VInt16 value ) {
  this->_shiftedStrips = value;
}
 
/** @brief set: Shifted strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setShiftedStrips( const std::string &value ) {
  this->_shiftedStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_shiftedStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_shiftedStrips.push_back( atoi(buf.c_str() ) );
}
 
 
void PedsFullNoiseAnalysisDescription::getShiftedStrips( VInt16 &value ) {
  value = this->_shiftedStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getShiftedStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_shiftedStrips.size(); i < size; ++i) {
    ss << sep << this->_shiftedStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LowNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setLowNoiseStrips( const VInt16 value ) {
  this->_lowNoiseStrips = value;
}
 
/** @brief set: LowNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setLowNoiseStrips( const std::string &value ) {
  this->_lowNoiseStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_lowNoiseStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_lowNoiseStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getLowNoiseStrips( VInt16 &value ) {
  value = this->_lowNoiseStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getLowNoiseStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_lowNoiseStrips.size(); i < size; ++i) {
    ss << sep << this->_lowNoiseStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setLargeNoiseStrips( const VInt16 value ) {
  this->_largeNoiseStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setLargeNoiseStrips( const std::string &value ) {
  this->_largeNoiseStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_largeNoiseStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_largeNoiseStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getLargeNoiseStrips( VInt16 &value ) {
  value = this->_largeNoiseStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getLargeNoiseStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_largeNoiseStrips.size(); i < size; ++i) {
    ss << sep << this->_largeNoiseStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setLargeNoiseSignifStrips( const VInt16 value ) {
  this->_largeNoiseSignifStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setLargeNoiseSignifStrips( const std::string &value ) {
  this->_largeNoiseSignifStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_largeNoiseSignifStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_largeNoiseSignifStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getLargeNoiseSignifStrips( VInt16 &value ) {
  value = this->_largeNoiseSignifStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getLargeNoiseSignifStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_largeNoiseSignifStrips.size(); i < size; ++i) {
    ss << sep << this->_largeNoiseSignifStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadFitStrips( const VInt16 value ) {
  this->_badFitStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadFitStrips( const std::string &value ) {
  this->_badFitStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badFitStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badFitStrips.push_back( atoi(buf.c_str() ) );
}
 
 
void PedsFullNoiseAnalysisDescription::getBadFitStrips( VInt16 &value ) {
  value = this->_badFitStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadFitStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badFitStrips.size(); i < size; ++i) {
    ss << sep << this->_badFitStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadADProbabStrips( const VInt16 value ) {
  this->_badADProbabStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadADProbabStrips( const std::string &value ) {
  this->_badADProbabStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badADProbabStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badADProbabStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadADProbabStrips( VInt16 &value ) {
  value = this->_badADProbabStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadADProbabStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badADProbabStrips.size(); i < size; ++i) {
    ss << sep << this->_badADProbabStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadKSProbabStrips( const VInt16 value ) {
  this->_badKSProbabStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadKSProbabStrips( const std::string &value ) {
  this->_badKSProbabStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badKSProbabStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badKSProbabStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadKSProbabStrips( VInt16 &value ) {
  value = this->_badKSProbabStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadKSProbabStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badKSProbabStrips.size(); i < size; ++i) {
    ss << sep << this->_badKSProbabStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadJBProbabStrips( const VInt16 value ) {
  this->_badJBProbabStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadJBProbabStrips( const std::string &value ) {
  this->_badJBProbabStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badJBProbabStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badJBProbabStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadJBProbabStrips( VInt16 &value ) {
  value = this->_badJBProbabStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadJBProbabStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badJBProbabStrips.size(); i < size; ++i) {
    ss << sep << this->_badJBProbabStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadChi2ProbabStrips( const VInt16 value ) {
  this->_badChi2ProbabStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadChi2ProbabStrips( const std::string &value ) {
  this->_badChi2ProbabStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badChi2ProbabStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badChi2ProbabStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadChi2ProbabStrips( VInt16 &value ) {
  value = this->_badChi2ProbabStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadChi2ProbabStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badChi2ProbabStrips.size(); i < size; ++i) {
    ss << sep << this->_badChi2ProbabStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadTailStrips( const VInt16 value ) {
  this->_badTailStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadTailStrips( const std::string &value ) {
  this->_badTailStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badTailStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badTailStrips.push_back( atoi(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getBadTailStrips( VInt16 &value ) {
  value = this->_badTailStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadTailStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badTailStrips.size(); i < size; ++i) {
    ss << sep << this->_badTailStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setBadDoublePeakStrips( const VInt16 value ) {
  this->_badDoublePeakStrips = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setBadDoublePeakStrips( const std::string &value ) {
  this->_badDoublePeakStrips.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badDoublePeakStrips.push_back( atoi(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badDoublePeakStrips.push_back( atoi(buf.c_str() ) );
}
 
 
void PedsFullNoiseAnalysisDescription::getBadDoublePeakStrips( VInt16 &value ) {
  value = this->_badTailStrips;
}
 
std::string PedsFullNoiseAnalysisDescription::getBadDoublePeakStrips() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badTailStrips.size(); i < size; ++i) {
    ss << sep << this->_badTailStrips[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
  
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setADProbab( const VFloat value ) {
  this->_adProbab = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setADProbab( const std::string &value ) {
  this->_adProbab.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_adProbab.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_adProbab.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getADProbab( VFloat &value ) {
  value = this->_adProbab;
}
 
std::string PedsFullNoiseAnalysisDescription::getADProbab() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_adProbab.size(); i < size; ++i) {
    ss << sep << std::setprecision(4) << this->_adProbab[i]  ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setKSProbab( const VFloat value ) {
  this->_ksProbab = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setKSProbab( const std::string &value ) {
  this->_ksProbab.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_ksProbab.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_ksProbab.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getKSProbab( VFloat &value ) {
  value = this->_ksProbab;
}
 
std::string PedsFullNoiseAnalysisDescription::getKSProbab() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_ksProbab.size(); i < size; ++i) {
    ss << sep << std::setprecision(4) <<  this->_ksProbab[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setJBProbab( const VFloat value ) {
  this->_jbProbab = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setJBProbab( const std::string &value ) {
  this->_jbProbab.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_jbProbab.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_jbProbab.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getJBProbab( VFloat &value ) {
  value = this->_jbProbab;
}
 
std::string PedsFullNoiseAnalysisDescription::getJBProbab() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_jbProbab.size(); i < size; ++i) {
    ss << sep << std::setprecision(8) << this->_jbProbab[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setChi2Probab( const VFloat value ) {
  this->_chi2Probab = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setChi2Probab( const std::string &value ) {
  this->_chi2Probab.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_chi2Probab.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_chi2Probab.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getChi2Probab( VFloat &value ) {
  value = this->_chi2Probab;
}
 
std::string PedsFullNoiseAnalysisDescription::getChi2Probab() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_chi2Probab.size(); i < size; ++i) {
    ss << sep << std::setprecision(8) << this->_chi2Probab[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
/** @brief set: LargeNoise strips values are strips numbers. */
void PedsFullNoiseAnalysisDescription::setNoiseRMS( const VFloat value ) {
  this->_noiseRMS = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setNoiseRMS( const std::string &value ) {
  this->_noiseRMS.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_noiseRMS.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_noiseRMS.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getNoiseRMS( VFloat &value ) {
  value = this->_noiseRMS;
}
 
std::string PedsFullNoiseAnalysisDescription::getNoiseRMS() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_noiseRMS.size(); i < size; ++i) {
    ss << sep << std::setprecision(3) << this->_noiseRMS[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
 
void PedsFullNoiseAnalysisDescription::setNoiseSigmaGaus( const VFloat value ) {
  this->_noiseSigmaGaus = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setNoiseSigmaGaus( const std::string &value ) {
  this->_noiseSigmaGaus.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_noiseSigmaGaus.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_noiseSigmaGaus.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getNoiseSigmaGaus( VFloat &value ) {
  value = this->_noiseSigmaGaus;
}
 
std::string PedsFullNoiseAnalysisDescription::getNoiseSigmaGaus() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_noiseSigmaGaus.size(); i < size; ++i) {
    ss << sep << std::setprecision(3) << this->_noiseSigmaGaus[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
void PedsFullNoiseAnalysisDescription::setNoiseSignificance( const VFloat value ) {
  this->_noiseSignificance = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setNoiseSignificance( const std::string &value ) {
  this->_noiseSignificance.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_noiseSignificance.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_noiseSignificance.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getNoiseSignificance( VFloat &value ) {
  value = this->_noiseSignificance;
}
 
std::string PedsFullNoiseAnalysisDescription::getNoiseSignificance() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_noiseSignificance.size(); i < size; ++i) {
    ss << sep << std::setprecision(3) << this->_noiseSignificance[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
void PedsFullNoiseAnalysisDescription::setResidualSkewness( const VFloat value ) {
  this->_residualSkewness = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setResidualSkewness( const std::string &value ) {
  this->_residualSkewness.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_residualSkewness.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_residualSkewness.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getResidualSkewness( VFloat &value ) {
  value = this->_residualSkewness;
}
 
std::string PedsFullNoiseAnalysisDescription::getResidualSkewness() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_residualSkewness.size(); i < size; ++i) {
    ss << sep << std::setprecision(2) << this->_residualSkewness[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
void PedsFullNoiseAnalysisDescription::setResidualKurtosis( const VFloat value ) {
  this->_residualKurtosis = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setResidualKurtosis( const std::string &value ) {
  this->_residualKurtosis.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_residualKurtosis.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_residualKurtosis.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getResidualKurtosis( VFloat &value ) {
  value = this->_residualKurtosis;
}
 
std::string PedsFullNoiseAnalysisDescription::getResidualKurtosis() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_residualKurtosis.size(); i < size; ++i) {
    ss << sep << std::setprecision(2) << this->_residualKurtosis[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
void PedsFullNoiseAnalysisDescription::setResidualIntegralNsigma( const VFloat value ) {
  this->_residualIntegralNsigma = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setResidualIntegralNsigma( const std::string &value ) {
  this->_residualIntegralNsigma.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_residualIntegralNsigma.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_residualIntegralNsigma.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getResidualIntegralNsigma( VFloat &value ) {
  value = this->_residualIntegralNsigma;
}
 
std::string PedsFullNoiseAnalysisDescription::getResidualIntegralNsigma() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_residualIntegralNsigma.size(); i < size; ++i) {
    ss << sep << std::setprecision(5) << this->_residualIntegralNsigma[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
void PedsFullNoiseAnalysisDescription::setResidualIntegral( const VFloat value ) {
  this->_residualIntegral = value;
}
 
/** @brief set: LargeNoise strips values are strips numbers concatened and separated by '|'. */
void PedsFullNoiseAnalysisDescription::setResidualIntegral( const std::string &value ) {
  this->_residualIntegral.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_residualIntegral.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_residualIntegral.push_back( atof(buf.c_str() ) );
}
 
void PedsFullNoiseAnalysisDescription::getResidualIntegral( VFloat &value ) {
  value = this->_residualIntegral;
}
 
std::string PedsFullNoiseAnalysisDescription::getResidualIntegral() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_residualIntegral.size(); i < size; ++i) {
    ss << sep << std::setprecision(5) << this->_residualIntegral[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
 
// internal methods                                                                                                                                                                                  
void PedsFullNoiseAnalysisDescription::setDeadStripBit( const VInt16 value){
  this->_deadStripBit = value;
}
 
void PedsFullNoiseAnalysisDescription::setDeadStripBit(){
  this->_deadStripBit.clear();
  for(unsigned int istrip = 0; istrip <= 127; istrip++) // fill all zeros
    this->_deadStripBit.push_back(0);

  for(unsigned int istrip = 0; istrip < this->_deadStrips.size(); istrip++){
    this->_deadStripBit.at(this->_deadStrips.at(istrip)) = 1;
  }

}
 
void PedsFullNoiseAnalysisDescription::setBadStripBit( const VInt16 value){
  this->_badStripBit = value;
}
 
void PedsFullNoiseAnalysisDescription::setBadStripBit(){
  this->_badStripBit.clear();
  for(unsigned int istrip = 0; istrip <= 127; istrip++) // fill all zeros
    this->_badStripBit.push_back(0);
 
  for(unsigned int istrip = 0; istrip < this->_badStrips.size(); istrip++)
    this->_badStripBit.at(this->_badStrips.at(istrip)) = 1;
 
}
 
void PedsFullNoiseAnalysisDescription::setReasonBadStripBit( const VInt16 value){
  this->_reasonBadStripBit = value;
}
 
void PedsFullNoiseAnalysisDescription::setReasonBadStripBit(){ // set the reason why a strip is flagged as bad
  this->_reasonBadStripBit.clear();
  for(unsigned int istrip = 0; istrip <= 127; istrip++) // fill all zeros  
    this->_reasonBadStripBit.push_back(0);
 
  std::string binaryNum = "";
  for(unsigned int istrip = 0; istrip < this->_reasonBadStripBit.size(); istrip++){ // binary criterion --> one bit for each possible condition

    if(this->_badStripBit.at(istrip) != 1) continue;
    
    bool isShifted = false;
    if(std::find(this->_shiftedStrips.begin(),this->_shiftedStrips.end(),(unsigned short) istrip) != this->_shiftedStrips.end())
      isShifted = true;
    bool isLowNoise = false;
    if(std::find(this->_lowNoiseStrips.begin(),this->_lowNoiseStrips.end(),(unsigned short) istrip) != this->_lowNoiseStrips.end())
      isLowNoise = true;
    bool isLargeNoise = false;
    if(std::find(this->_largeNoiseStrips.begin(),this->_largeNoiseStrips.end(),(unsigned short) istrip) != this->_largeNoiseStrips.end())
      isLargeNoise = true;
    bool isLargeNoiseSignif = false;
    if(std::find(this->_largeNoiseSignifStrips.begin(),this->_largeNoiseSignifStrips.end(),(unsigned short) istrip) != this->_largeNoiseSignifStrips.end())
      isLargeNoiseSignif = true;
    bool isBadFit = false;
    if(std::find(this->_badFitStrips.begin(),this->_badFitStrips.end(),(unsigned short) istrip) != this->_badFitStrips.end())
      isBadFit = true;
    bool isBadADProbab = false;
    if(std::find(this->_badADProbabStrips.begin(),this->_badADProbabStrips.end(),(unsigned short) istrip) != this->_badADProbabStrips.end())
      isBadADProbab = true;
    bool isBadKSProbab = false;
    if(std::find(this->_badKSProbabStrips.begin(),this->_badKSProbabStrips.end(),(unsigned short) istrip) != this->_badKSProbabStrips.end())
      isBadKSProbab = true;
    bool isBadJBProbab = false;
    if(std::find(this->_badJBProbabStrips.begin(),this->_badJBProbabStrips.end(),(unsigned short) istrip) != this->_badJBProbabStrips.end())
      isBadJBProbab = true;
    bool isBadChi2Probab = false;
    if(std::find(this->_badChi2ProbabStrips.begin(),this->_badChi2ProbabStrips.end(),(unsigned short) istrip) != this->_badChi2ProbabStrips.end())
      isBadChi2Probab = true;
    bool isBadTail = false;
    if(std::find(this->_badTailStrips.begin(),this->_badTailStrips.end(),(unsigned short) istrip) != this->_badTailStrips.end())
      isBadTail = true;
    bool isBadDoublePeak = false;
    if(std::find(this->_badDoublePeakStrips.begin(),this->_badDoublePeakStrips.end(),(unsigned short) istrip) != this->_badDoublePeakStrips.end())
      isBadDoublePeak = true;

    //////////
    this->_reasonBadStripBit.at(istrip) = isBadDoublePeak << 10 | isBadTail << 9 | isBadChi2Probab << 8 | isBadJBProbab << 7 | isBadKSProbab << 6 | isBadADProbab << 5 | isBadFit << 4 | isLargeNoiseSignif << 3 | isLargeNoise << 2 | isLowNoise << 1 | isShifted ;

  }

}
 
void PedsFullNoiseAnalysisDescription::setFractionOverN( const VFloat value){
  this->_fractionOverN = value;
}
 
void PedsFullNoiseAnalysisDescription::setFractionOverN(){
  this->_fractionOverN.clear();
  for(unsigned int istrip = 0; istrip < this->_residualIntegralNsigma.size(); istrip++)
    this->_fractionOverN.push_back(this->_residualIntegralNsigma.at(istrip)/this->_residualIntegral.at(istrip));
}
 
 
///
void PedsFullNoiseAnalysisDescription::setDeadStripBit( const std::string &value ){
  this->_deadStripBit.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_deadStripBit.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_deadStripBit.push_back( atof(buf.c_str() ) );


}
void PedsFullNoiseAnalysisDescription::setBadStripBit( const std::string &value ){
  this->_badStripBit.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_badStripBit.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_badStripBit.push_back( atof(buf.c_str() ) );
}
void PedsFullNoiseAnalysisDescription::setReasonBadStripBit( const std::string &value ){
  this->_reasonBadStripBit.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_reasonBadStripBit.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_reasonBadStripBit.push_back( atof(buf.c_str() ) );
}
void PedsFullNoiseAnalysisDescription::setFractionOverN( const std::string &value ){
  this->_fractionOverN.clear();
  if ( value.empty() ) return;
  std::string buf;
  for (unsigned int i = 0, size = value.size(); i < size; i++) {
    if ( value[i]=='|' ) {
      this->_fractionOverN.push_back( atof(buf.c_str() ) );
      buf.erase();
    } else {
      buf.append(value, i, 1);
    }
  }
  if ( buf != "" )
    this->_fractionOverN.push_back( atof(buf.c_str() ) );
}
 
std::string PedsFullNoiseAnalysisDescription::getDeadStripBit() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_deadStripBit.size(); i < size; ++i) {
    ss << sep << this->_deadStripBit[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
std::string PedsFullNoiseAnalysisDescription::getBadStripBit() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_badStripBit.size(); i < size; ++i) {
    ss << sep << this->_badStripBit[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 

std::string PedsFullNoiseAnalysisDescription::getReasonBadStripBit() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_reasonBadStripBit.size(); i < size; ++i) {
    ss << sep << this->_reasonBadStripBit[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
 
}
 
std::string PedsFullNoiseAnalysisDescription::getFractionOverN() const {
  std::stringstream ss;
  std::string sep("");
  for (unsigned int i = 0, size = this->_fractionOverN.size(); i < size; ++i) {
    ss << sep << std::setprecision(2) << this->_fractionOverN[i] ;
    sep="|";
  }
  return ss.rdbuf()->str();
}
 
void PedsFullNoiseAnalysisDescription::getDeadStripBit(VInt16 & value){
  value = this->_deadStripBit;
}
void PedsFullNoiseAnalysisDescription::getBadStripBit(VInt16 & value){
  value = this->_badStripBit;
}
void PedsFullNoiseAnalysisDescription::getReasonBadStripBit(VInt16 & value){
  value = this->_reasonBadStripBit;
}
 
void PedsFullNoiseAnalysisDescription::getFractionOverN(VFloat & value){
  value = this->_fractionOverN;
}
 
